<h1 align=center>
Boilr
<br>
<img src="/assets/logo.png" height="360">
<br>
</h1>

[![Quality Gate Status](https://sonarqube.sifs0005.infs.ch/api/project_badges/measure?project=ifs_boilr_AYcNxIdW_ZxZ7IiqooQR&metric=alert_status&token=sqb_12af9368414c7eb7f93d726a06c3ed0b3ee974fb)](https://sonarqube.sifs0005.infs.ch/dashboard?id=ifs_boilr_AYcNxIdW_ZxZ7IiqooQR) [![Reliability Rating](https://sonarqube.sifs0005.infs.ch/api/project_badges/measure?project=ifs_boilr_AYcNxIdW_ZxZ7IiqooQR&metric=reliability_rating&token=sqb_12af9368414c7eb7f93d726a06c3ed0b3ee974fb)](https://sonarqube.sifs0005.infs.ch/dashboard?id=ifs_boilr_AYcNxIdW_ZxZ7IiqooQR)

# Boilr usage

Download a release from the [release page](https://gitlab.ost.ch/ifs/boilr/-/releases) matching your architecture.
Then follow the instructions below.

## Notes

this is a fork of the fork of the original project, to get a build pipeline that creates binary version to download and use for Windows, Mac (M1/M2/Intel) and Linux (32 bit and 64 bit).

## Installation

Binaries for Windows, Linux and OSX are built automatically by the giltab-ci every release.

To get the newest release for your system,
the latest release can be found under [https://gitlab.ost.ch/ifs/boilr/-/releases/permalink/latest](https://gitlab.ost.ch/ifs/boilr/-/releases/permalink/latest)

All the available releases can be found under the [releases tab of the repo](https://gitlab.ost.ch/ifs/boilr/-/releases)

### Windows

FIXME: Installation is currently not straight-forward.

1. Go to the [latest release page](https://gitlab.ost.ch/ifs/boilr/-/releases/permalink/latest/)
2. download the windows binary (most likely the boilr-windows-amd64.exe)
3. Use it with your commandline.

### OSX

FIXME: Unsure what OSX needs.

1. Go to the [latest release page](https://gitlab.ost.ch/ifs/boilr/-/releases/permalink/latest/)
2. download the OSX binary (M1/M2 and Intel 64-bit)
3. Use it with your commandline.

## Linux

To get the newest release you can run the following commands (change to amd64 to 386 if needed):

### Latest

```bash
rm -f ~/bin/boilr
wget -O boilr https://gitlab.ost.ch/ifs/boilr/-/releases/permalink/latest/downloads/binaries/boilr-linux-amd64
install boilr ~/bin/boilr
# or, if system wide installation is preferred:
# sudo rm -f /usr/bin/boilr
# sudo install boilr /usr/bin/boilr
rm boilr
# test
boilr version
```

### Specific Version

Example with Version 0.3.5:

```bash
rm -f ~/bin/boilr
wget -O boilr https://gitlab.ost.ch/ifs/boilr/-/releases/0.3.5/downloads/binaries/boilr-linux-amd64
install boilr ~/bin/boilr
# or, if system wide installation is preferred:
# sudo install boilr /usr/bin/boilr
rm boilr
```

## Initialisation

Execute `boilr init` (on Windows `boilr.exe init`).

## Usage

See below.


## Information From Fork of the Fork - may be out of date

<p align=center>
<em>Are you doing the <b>same steps over and over again</b> every time you start a new programming project?</em>
<br><br>
<em>Boilr is here to help you <b>create projects from boilerplate templates</b>.</em>
</p>

![Usage Demonstration](assets/usage.gif)

For more details, see [Introduction](https://github.com/tmrts/boilr/wiki/Introduction) page.


# Features
* **No dependencies (NodeJS, Python Interpreter etc.)** - Boilr is a single statically linked binary.
Grab the one that fits your architecture, and you're all set to save time by using templates!
* **Full Power of [Golang Templates](https://golang.org/pkg/text/template/)** - Golang has powerful templating
constructs which are very easy to learn and powerful.
* **Dead-Simple Template Creation** - Creating boilerplate templates are very easy, check out
the [license template](https://github.com/tmrts/boilr-license) to see a simple, but very useful template for
adding licenses to new projects with a single command.


# Getting Started with Boilr
Use `boilr help` to get the list of available commands.

## Download a Template
In order to download a template from a github repository, use the following command:

```bash
boilr template download <github-repo-path> <template-tag>
boilr template download tmrts/boilr-license license
```

The downloaded template will be saved to local `boilr` registry.

## Save a Local Template
In order to save a template from filesystem to the template registry use the following command:

```bash
boilr template save <template-path> <template-tag>
boilr template save ~/boilr-license license
```

The saved template will be saved to local `boilr` registry.

## Use a Template
For a Boilr template with the given directory structure:

```tree
.
├── project.json
├── README.md
└── template
    └── LICENSE
```

And the following `project.json` context file:

```json
{
    "Author": "Tamer Tas",
    "Year": "2015",
    "License": [
        "Apache Software License 2.0",
        "MIT",
        "GNU GPL v3.0"
    ]
}
```

When using the template with the following command:

```bash
boilr template use <template-tag> <target-dir>
boilr template use license /workspace/tmrts/example-project/
```

The user will be prompted as follows:

```bash
[?] Please choose an option for "License"
    1 -  "Apache Software License 2.0"
    2 -  "MIT"
    3 -  "GNU GPL v3.0"
    Select from 1..3 [default: 1]: 2
[?] Please choose a value for "Year" [default: "2015"]:
[?] Please choose a value for "Author" [default: "Tamer Tas"]:
[✔] Created /workspace/tmrts/example-project/LICENSE
[✔] Successfully executed the project template license in /workspace/tmrts/example-project
```

For more information please take a look at [Usage](https://github.com/tmrts/boilr/wiki/Usage) and [Creating Templates](https://github.com/tmrts/boilr/wiki/Creating-Templates) pages in the wiki.

# List of Templates

<img alt="Electron Logo" height=96 width=96
src="https://cdn.rawgit.com/tmrts/boilr/master/assets/template-logos/electron.svg" />
<img alt="Docker Logo" height=96 width=96
src="https://cdn.rawgit.com/tmrts/boilr/master/assets/template-logos/docker.svg" />
<img alt="Kubernetes Logo" height=96 width=96
src="https://cdn.rawgit.com/tmrts/boilr/master/assets/template-logos/kubernetes.svg" />

Take a look at the [Templates](https://github.com/tmrts/boilr/wiki/Templates) page for an index of project templates, examples, and more information.

# Need Help? Found a bug? Want a Feature?
If you'd like to contribute, share your opinions or ask questions, please feel free to open an issue.

At this stage, user feedback is of **utmost importance**, every contribution is welcome however small it may be.
