#!/usr/bin/env bash

package_name=$1
package=$2
if [[ -z "$package" ]]; then
  echo "usage: $0 <package-name> <go-directory-or-file-to-build>"
  exit 1
fi

package_split=(${package_name//\// })
package_name=${package_split[-1]}
target_folder="builds/"


platforms=("windows/amd64" "windows/386" "darwin/amd64" "darwin/arm64" "linux/amd64" "linux/386")

for platform in "${platforms[@]}"
do
	platform_split=(${platform//\// })
	GOOS=${platform_split[0]}
	GOARCH=${platform_split[1]}
	output_name=$package_name'-'$GOOS'-'$GOARCH
	if [ $GOOS = "windows" ]; then
		output_name+='.exe'
	fi	

	env GOOS=$GOOS GOARCH=$GOARCH go build -o $target_folder$output_name $package
	if [ $? -ne 0 ]; then
   		echo 'An error has occurred! Aborting the script execution...'
		exit 1
	fi
done
